=== random/CMakeLists.txt ===
badvpn_add_library(badvpn_random "base" "" BRandom2.c)
